pub const NONE: u8 = 0b0000;

pub const TOP: u8 = 0b0001;
pub const BOTTOM: u8 = 0b0010;
pub const LEFT: u8 = 0b0100;
pub const RIGHT: u8 = 0b1000;

pub const BOTTOM_RIGHT: u8 = BOTTOM | RIGHT;
pub const BOTTOM_LEFT_RIGHT: u8 = BOTTOM | LEFT | RIGHT;
pub const BOTTOM_LEFT: u8 = BOTTOM | LEFT;
pub const TOP_BOTTOM_RIGHT: u8 = TOP | BOTTOM | RIGHT;
pub const TOP_BOTTOM_LEFT_RIGHT: u8 = TOP | BOTTOM | LEFT | RIGHT;
pub const TOP_BOTTOM_LEFT: u8 = TOP | BOTTOM | LEFT;
pub const TOP_RIGHT: u8 = TOP | RIGHT;
pub const TOP_LEFT_RIGHT: u8 = TOP | LEFT | RIGHT;
pub const TOP_LEFT: u8 = TOP | LEFT;
pub const TOP_BOTTOM: u8 = TOP | BOTTOM;
pub const LEFT_RIGHT: u8 = LEFT | RIGHT;

pub fn get_floor_sprite_offset(adjacency: u8) -> usize {
	match adjacency {
		BOTTOM_RIGHT => 0,
		BOTTOM_LEFT_RIGHT => 1,
		BOTTOM_LEFT => 2,
		BOTTOM => 3,
		TOP_BOTTOM_RIGHT => 64,
		TOP_BOTTOM_LEFT_RIGHT => 64 + 1,
		TOP_BOTTOM_LEFT => 64 + 2,
		TOP_BOTTOM => 64 + 3,
		RIGHT => 64 + 4,
		LEFT_RIGHT => 64 + 5,
		LEFT => 64 + 6,
		TOP_RIGHT => 128,
		TOP_LEFT_RIGHT => 128 + 1,
		TOP_LEFT => 128 + 2,
		TOP => 128 + 3,
		NONE | _ => 5,
	}
}

pub fn get_wall_sprite_offset(adjacency: u8) -> usize {
	match adjacency {
		BOTTOM_RIGHT => 0,
		LEFT_RIGHT => 1,
		BOTTOM_LEFT => 2,
		BOTTOM_LEFT_RIGHT => 4,
		TOP_BOTTOM | BOTTOM => 64,
		NONE | TOP => 64 + 1,
		TOP_BOTTOM_RIGHT => 64 + 3,
		TOP_BOTTOM_LEFT_RIGHT => 64 + 4,
		TOP_BOTTOM_LEFT => 64 + 5,
		TOP_RIGHT | RIGHT => 128,
		TOP_LEFT | LEFT => 128 + 2,
		TOP_LEFT_RIGHT => 128 + 4,
		_ => 3,
	}
}
