pub mod adjacency;
pub mod generators;
pub mod handlers;
pub mod level_map;
pub mod pathing;

mod __plugin {
	use bevy::app::{App, CoreStage, Plugin};
	use iyes_loopless::condition::ConditionSet;

	use crate::system::flow::AppState;

	pub struct WorldPlugin;
	impl Plugin for WorldPlugin {
		fn build(&self, app: &mut App) {
			app.add_system_set_to_stage(
				CoreStage::PostUpdate,
				ConditionSet::new()
					.run_in_state(AppState::InGame)
					.with_system(super::handlers::spawn_new_world)
					.with_system(super::level_map::sync_grid_to_transform)
					.into(),
			);
		}
	}
}

pub use __plugin::WorldPlugin;
